Browse code

Merge remote-tracking branch 'origin/packaging'

Solomon Hykes authored on 2013/04/14 13:40:53
Showing 35 changed files
1 1
deleted file mode 120000
... ...
@@ -1 +0,0 @@
1
-../Makefile
2 1
\ No newline at end of file
3 2
deleted file mode 100644
... ...
@@ -1,73 +0,0 @@
1
-PKG_NAME=dotcloud-docker
2
-PKG_ARCH=amd64
3
-PKG_VERSION=1
4
-ROOT_PATH:=$(PWD)
5
-BUILD_PATH=build	# Do not change, decided by dpkg-buildpackage
6
-BUILD_SRC=build_src
7
-GITHUB_PATH=src/github.com/dotcloud/docker
8
-INSDIR=usr/bin
9
-SOURCE_PACKAGE=$(PKG_NAME)_$(PKG_VERSION).orig.tar.gz
10
-DEB_PACKAGE=$(PKG_NAME)_$(PKG_VERSION)_$(PKG_ARCH).deb
11
-EXTRA_GO_PKG=./auth
12
-
13
-TMPDIR=$(shell mktemp -d -t XXXXXX)
14
-
15
-
16
-# Build a debian source package
17
-all: clean build_in_deb
18
-
19
-build_in_deb:
20
-	echo "GOPATH = " $(ROOT_PATH)
21
-	mkdir bin
22
-	cd $(GITHUB_PATH)/docker; GOPATH=$(ROOT_PATH) go build -o $(ROOT_PATH)/bin/docker
23
-
24
-# DESTDIR provided by Debian packaging
25
-install:
26
-	# Call this from a go environment (as packaged for deb source package)
27
-	mkdir -p $(DESTDIR)/$(INSDIR)
28
-	mkdir -p $(DESTDIR)/etc/init
29
-	install -m 0755 bin/docker $(DESTDIR)/$(INSDIR)
30
-	install -o root -m 0755 etc/docker.upstart $(DESTDIR)/etc/init/docker.conf
31
-
32
-$(BUILD_SRC): clean
33
-	# Copy ourselves into $BUILD_SRC to comply with unusual golang constraints
34
-	tar --exclude=*.tar.gz --exclude=checkout.tgz -f checkout.tgz -cz *
35
-	mkdir -p $(BUILD_SRC)/$(GITHUB_PATH)
36
-	tar -f checkout.tgz -C $(BUILD_SRC)/$(GITHUB_PATH) -xz
37
-	cd $(BUILD_SRC)/$(GITHUB_PATH)/docker; GOPATH=$(ROOT_PATH)/$(BUILD_SRC) go get -d
38
-	for d in `find $(BUILD_SRC) -name '.git*'`; do rm -rf $$d; done
39
-	# Populate source build with debian stuff
40
-	cp -R -L ./deb/* $(BUILD_SRC)
41
-
42
-$(SOURCE_PACKAGE): $(BUILD_SRC)
43
-	rm -f $(SOURCE_PACKAGE)
44
-	# Create the debian source package
45
-	tar -f $(SOURCE_PACKAGE) -C ${ROOT_PATH}/${BUILD_SRC} -cz .
46
-
47
-# Build deb package fetching go dependencies and cleaning up git repositories
48
-deb: $(DEB_PACKAGE)
49
-
50
-$(DEB_PACKAGE): $(SOURCE_PACKAGE)
51
-	# dpkg-buildpackage looks for source package tarball in ../
52
-	cd $(BUILD_SRC); dpkg-buildpackage
53
-	rm -rf $(BUILD_PATH) debian/$(PKG_NAME)* debian/files
54
-
55
-debsrc: $(SOURCE_PACKAGE)
56
-
57
-# Build local sources
58
-#$(PKG_NAME): build_local
59
-
60
-build_local:
61
-	-@mkdir -p bin
62
-	cd docker && go build -o ../bin/docker
63
-
64
-gotest:
65
-	@echo "\033[36m[Testing]\033[00m docker..."
66
-	@sudo -E GOPATH=$(ROOT_PATH)/$(BUILD_SRC) go test -v . $(EXTRA_GO_PKG) && \
67
-		echo -n "\033[32m[OK]\033[00m" || \
68
-		echo -n "\033[31m[FAIL]\033[00m"; \
69
-		echo " docker"
70
-	@sudo rm -rf /tmp/docker-*
71
-
72
-clean:
73
-	rm -rf $(BUILD_PATH) debian/$(PKG_NAME)* debian/files $(BUILD_SRC) checkout.tgz bin
74 1
deleted file mode 120000
... ...
@@ -1 +0,0 @@
1
-../README.md
2 1
\ No newline at end of file
3 2
deleted file mode 100644
... ...
@@ -1,5 +0,0 @@
1
-dotcloud-docker (1) precise; urgency=low
2
-
3
-  * Initial release
4
-
5
- -- dotCloud <ops@dotcloud.com>  Mon, 14 Mar 2013 04:43:21 -0700
6 1
deleted file mode 100644
... ...
@@ -1 +0,0 @@
1
-8
2 1
deleted file mode 100644
... ...
@@ -1,20 +0,0 @@
1
-Source: dotcloud-docker
2
-Section: misc
3
-Priority: extra
4
-Homepage: https://github.com/dotcloud/docker
5
-Maintainer: Daniel Mizyrycki <daniel@dotcloud.com>
6
-Build-Depends: debhelper (>= 8.0.0), git, golang
7
-Vcs-Git: https://github.com/dotcloud/docker.git
8
-Standards-Version: 3.9.2
9
-
10
-Package: dotcloud-docker
11
-Architecture: amd64
12
-Provides: dotcloud-docker
13
-Depends: lxc, wget, bsdtar, curl
14
-Conflicts: docker
15
-Description: A process manager with superpowers
16
-    It encapsulates heterogeneous payloads in Standard Containers, and runs
17
-    them on any server with strong guarantees of isolation and repeatability.
18
-    Is is a great building block for automating distributed systems:
19
-    large-scale web deployments, database clusters, continuous deployment
20
-    systems, private PaaS, service-oriented architectures, etc.
21 1
deleted file mode 100644
... ...
@@ -1,209 +0,0 @@
1
-Format: http://dep.debian.net/deps/dep5
2
-Upstream-Name: dotcloud-docker
3
-Source: https://github.com/dotcloud/docker
4
-
5
-Files: *
6
-Copyright: 2012 DotCloud Inc (opensource@dotcloud.com)
7
-License: Apache License Version 2.0
8
-
9
-                                Apache License
10
-                           Version 2.0, January 2004
11
-                        http://www.apache.org/licenses/
12
-
13
-   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
14
-
15
-   1. Definitions.
16
-
17
-      "License" shall mean the terms and conditions for use, reproduction,
18
-      and distribution as defined by Sections 1 through 9 of this document.
19
-
20
-      "Licensor" shall mean the copyright owner or entity authorized by
21
-      the copyright owner that is granting the License.
22
-
23
-      "Legal Entity" shall mean the union of the acting entity and all
24
-      other entities that control, are controlled by, or are under common
25
-      control with that entity. For the purposes of this definition,
26
-      "control" means (i) the power, direct or indirect, to cause the
27
-      direction or management of such entity, whether by contract or
28
-      otherwise, or (ii) ownership of fifty percent (50%) or more of the
29
-      outstanding shares, or (iii) beneficial ownership of such entity.
30
-
31
-      "You" (or "Your") shall mean an individual or Legal Entity
32
-      exercising permissions granted by this License.
33
-
34
-      "Source" form shall mean the preferred form for making modifications,
35
-      including but not limited to software source code, documentation
36
-      source, and configuration files.
37
-
38
-      "Object" form shall mean any form resulting from mechanical
39
-      transformation or translation of a Source form, including but
40
-      not limited to compiled object code, generated documentation,
41
-      and conversions to other media types.
42
-
43
-      "Work" shall mean the work of authorship, whether in Source or
44
-      Object form, made available under the License, as indicated by a
45
-      copyright notice that is included in or attached to the work
46
-      (an example is provided in the Appendix below).
47
-
48
-      "Derivative Works" shall mean any work, whether in Source or Object
49
-      form, that is based on (or derived from) the Work and for which the
50
-      editorial revisions, annotations, elaborations, or other modifications
51
-      represent, as a whole, an original work of authorship. For the purposes
52
-      of this License, Derivative Works shall not include works that remain
53
-      separable from, or merely link (or bind by name) to the interfaces of,
54
-      the Work and Derivative Works thereof.
55
-
56
-      "Contribution" shall mean any work of authorship, including
57
-      the original version of the Work and any modifications or additions
58
-      to that Work or Derivative Works thereof, that is intentionally
59
-      submitted to Licensor for inclusion in the Work by the copyright owner
60
-      or by an individual or Legal Entity authorized to submit on behalf of
61
-      the copyright owner. For the purposes of this definition, "submitted"
62
-      means any form of electronic, verbal, or written communication sent
63
-      to the Licensor or its representatives, including but not limited to
64
-      communication on electronic mailing lists, source code control systems,
65
-      and issue tracking systems that are managed by, or on behalf of, the
66
-      Licensor for the purpose of discussing and improving the Work, but
67
-      excluding communication that is conspicuously marked or otherwise
68
-      designated in writing by the copyright owner as "Not a Contribution."
69
-
70
-      "Contributor" shall mean Licensor and any individual or Legal Entity
71
-      on behalf of whom a Contribution has been received by Licensor and
72
-      subsequently incorporated within the Work.
73
-
74
-   2. Grant of Copyright License. Subject to the terms and conditions of
75
-      this License, each Contributor hereby grants to You a perpetual,
76
-      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
77
-      copyright license to reproduce, prepare Derivative Works of,
78
-      publicly display, publicly perform, sublicense, and distribute the
79
-      Work and such Derivative Works in Source or Object form.
80
-
81
-   3. Grant of Patent License. Subject to the terms and conditions of
82
-      this License, each Contributor hereby grants to You a perpetual,
83
-      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
84
-      (except as stated in this section) patent license to make, have made,
85
-      use, offer to sell, sell, import, and otherwise transfer the Work,
86
-      where such license applies only to those patent claims licensable
87
-      by such Contributor that are necessarily infringed by their
88
-      Contribution(s) alone or by combination of their Contribution(s)
89
-      with the Work to which such Contribution(s) was submitted. If You
90
-      institute patent litigation against any entity (including a
91
-      cross-claim or counterclaim in a lawsuit) alleging that the Work
92
-      or a Contribution incorporated within the Work constitutes direct
93
-      or contributory patent infringement, then any patent licenses
94
-      granted to You under this License for that Work shall terminate
95
-      as of the date such litigation is filed.
96
-
97
-   4. Redistribution. You may reproduce and distribute copies of the
98
-      Work or Derivative Works thereof in any medium, with or without
99
-      modifications, and in Source or Object form, provided that You
100
-      meet the following conditions:
101
-
102
-      (a) You must give any other recipients of the Work or
103
-          Derivative Works a copy of this License; and
104
-
105
-      (b) You must cause any modified files to carry prominent notices
106
-          stating that You changed the files; and
107
-
108
-      (c) You must retain, in the Source form of any Derivative Works
109
-          that You distribute, all copyright, patent, trademark, and
110
-          attribution notices from the Source form of the Work,
111
-          excluding those notices that do not pertain to any part of
112
-          the Derivative Works; and
113
-
114
-      (d) If the Work includes a "NOTICE" text file as part of its
115
-          distribution, then any Derivative Works that You distribute must
116
-          include a readable copy of the attribution notices contained
117
-          within such NOTICE file, excluding those notices that do not
118
-          pertain to any part of the Derivative Works, in at least one
119
-          of the following places: within a NOTICE text file distributed
120
-          as part of the Derivative Works; within the Source form or
121
-          documentation, if provided along with the Derivative Works; or,
122
-          within a display generated by the Derivative Works, if and
123
-          wherever such third-party notices normally appear. The contents
124
-          of the NOTICE file are for informational purposes only and
125
-          do not modify the License. You may add Your own attribution
126
-          notices within Derivative Works that You distribute, alongside
127
-          or as an addendum to the NOTICE text from the Work, provided
128
-          that such additional attribution notices cannot be construed
129
-          as modifying the License.
130
-
131
-      You may add Your own copyright statement to Your modifications and
132
-      may provide additional or different license terms and conditions
133
-      for use, reproduction, or distribution of Your modifications, or
134
-      for any such Derivative Works as a whole, provided Your use,
135
-      reproduction, and distribution of the Work otherwise complies with
136
-      the conditions stated in this License.
137
-
138
-   5. Submission of Contributions. Unless You explicitly state otherwise,
139
-      any Contribution intentionally submitted for inclusion in the Work
140
-      by You to the Licensor shall be under the terms and conditions of
141
-      this License, without any additional terms or conditions.
142
-      Notwithstanding the above, nothing herein shall supersede or modify
143
-      the terms of any separate license agreement you may have executed
144
-      with Licensor regarding such Contributions.
145
-
146
-   6. Trademarks. This License does not grant permission to use the trade
147
-      names, trademarks, service marks, or product names of the Licensor,
148
-      except as required for reasonable and customary use in describing the
149
-      origin of the Work and reproducing the content of the NOTICE file.
150
-
151
-   7. Disclaimer of Warranty. Unless required by applicable law or
152
-      agreed to in writing, Licensor provides the Work (and each
153
-      Contributor provides its Contributions) on an "AS IS" BASIS,
154
-      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
155
-      implied, including, without limitation, any warranties or conditions
156
-      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
157
-      PARTICULAR PURPOSE. You are solely responsible for determining the
158
-      appropriateness of using or redistributing the Work and assume any
159
-      risks associated with Your exercise of permissions under this License.
160
-
161
-   8. Limitation of Liability. In no event and under no legal theory,
162
-      whether in tort (including negligence), contract, or otherwise,
163
-      unless required by applicable law (such as deliberate and grossly
164
-      negligent acts) or agreed to in writing, shall any Contributor be
165
-      liable to You for damages, including any direct, indirect, special,
166
-      incidental, or consequential damages of any character arising as a
167
-      result of this License or out of the use or inability to use the
168
-      Work (including but not limited to damages for loss of goodwill,
169
-      work stoppage, computer failure or malfunction, or any and all
170
-      other commercial damages or losses), even if such Contributor
171
-      has been advised of the possibility of such damages.
172
-
173
-   9. Accepting Warranty or Additional Liability. While redistributing
174
-      the Work or Derivative Works thereof, You may choose to offer,
175
-      and charge a fee for, acceptance of support, warranty, indemnity,
176
-      or other liability obligations and/or rights consistent with this
177
-      License. However, in accepting such obligations, You may act only
178
-      on Your own behalf and on Your sole responsibility, not on behalf
179
-      of any other Contributor, and only if You agree to indemnify,
180
-      defend, and hold each Contributor harmless for any liability
181
-      incurred by, or claims asserted against, such Contributor by reason
182
-      of your accepting any such warranty or additional liability.
183
-
184
-   END OF TERMS AND CONDITIONS
185
-
186
-   APPENDIX: How to apply the Apache License to your work.
187
-
188
-      To apply the Apache License to your work, attach the following
189
-      boilerplate notice, with the fields enclosed by brackets "[]"
190
-      replaced with your own identifying information. (Don't include
191
-      the brackets!) The text should be enclosed in the appropriate
192
-      comment syntax for the file format. We also recommend that a
193
-      file or class name and description of purpose be included on the
194
-      same "printed page" as the copyright notice for easier
195
-      identification within third-party archives.
196
-
197
-   Copyright 2012 DotCloud Inc (opensource@dotcloud.com)
198
-
199
-   Licensed under the Apache License, Version 2.0 (the "License");
200
-   you may not use this file except in compliance with the License.
201
-   You may obtain a copy of the License at
202
-
203
-       http://www.apache.org/licenses/LICENSE-2.0
204
-
205
-   Unless required by applicable law or agreed to in writing, software
206
-   distributed under the License is distributed on an "AS IS" BASIS,
207
-   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
208
-   See the License for the specific language governing permissions and
209
-   limitations under the License.
210 1
deleted file mode 100644
... ...
@@ -1 +0,0 @@
1
-README.md
2 1
deleted file mode 100755
... ...
@@ -1,13 +0,0 @@
1
-#!/usr/bin/make -f
2
-# -*- makefile -*-
3
-# Sample debian/rules that uses debhelper.
4
-# This file was originally written by Joey Hess and Craig Small.
5
-# As a special exception, when this file is copied by dh-make into a
6
-# dh-make output file, you may use that output file without restriction.
7
-# This special exception was added by Craig Small in version 0.37 of dh-make.
8
-
9
-# Uncomment this to turn on verbose mode.
10
-#export DH_VERBOSE=1
11
-
12
-%:
13
-	dh $@
14 1
deleted file mode 100644
... ...
@@ -1 +0,0 @@
1
-3.0 (quilt)
2 1
deleted file mode 100644
... ...
@@ -1,10 +0,0 @@
1
-description     "Run docker"
2
-
3
-start on runlevel [2345]
4
-stop on starting rc RUNLEVEL=[016]
5
-respawn
6
-
7
-script
8
-    test -f /etc/default/locale && . /etc/default/locale || true
9
-    LANG=$LANG LC_ALL=$LANG /usr/bin/docker -d
10
-end script
11 1
deleted file mode 100644
... ...
@@ -1,10 +0,0 @@
1
-description     "Run docker"
2
-
3
-start on runlevel [2345]
4
-stop on starting rc RUNLEVEL=[016]
5
-respawn
6
-
7
-script
8
-    test -f /etc/default/locale && . /etc/default/locale || true
9
-    LANG=$LANG LC_ALL=$LANG /usr/bin/docker -d
10
-end script
11 1
new file mode 100644
... ...
@@ -0,0 +1,8 @@
0
+Docker packaging
1
+================
2
+
3
+This directory has one subdirectory per packaging distribution.
4
+At minimum, each of these subdirectories should contain a
5
+README.$DISTRIBUTION explaining how to create the native
6
+docker package and how to install it.
7
+
0 8
new file mode 100644
... ...
@@ -0,0 +1,35 @@
0
+PKG_NAME=lxc-docker
1
+DOCKER_VERSION=$(shell head -1 changelog | awk 'match($$0, /\(.+\)/) {print substr($$0, RSTART+1, RLENGTH-4)}')
2
+GITHUB_PATH=github.com/dotcloud/docker
3
+SOURCE_PKG=$(PKG_NAME)_$(DOCKER_VERSION).orig.tar.gz
4
+BUILD_SRC=${CURDIR}/../../build_src
5
+
6
+all:
7
+	# Compile docker. Used by debian dpkg-buildpackage. 
8
+	cd src/${GITHUB_PATH}/docker; GOPATH=${CURDIR} go build
9
+
10
+install:
11
+	# Used by debian dpkg-buildpackage 
12
+	mkdir -p $(DESTDIR)/usr/bin
13
+	mkdir -p $(DESTDIR)/etc/init.d
14
+	install -m 0755 src/${GITHUB_PATH}/docker/docker $(DESTDIR)/usr/bin
15
+	install -o root -m 0755 debian/docker.initd $(DESTDIR)/etc/init.d/docker
16
+
17
+debian:
18
+	# This Makefile will compile the github master branch of dotcloud/docker
19
+	# Retrieve docker project and its go structure from internet
20
+	rm -rf ${BUILD_SRC}
21
+	GOPATH=${BUILD_SRC} go get ${GITHUB_PATH}
22
+	# Add debianization
23
+	mkdir ${BUILD_SRC}/debian
24
+	cp Makefile ${BUILD_SRC}
25
+	cp -r * ${BUILD_SRC}/debian
26
+	cp ../../README.md ${BUILD_SRC}
27
+	# Cleanup
28
+	for d in `find ${BUILD_SRC} -name '.git*'`; do rm -rf $$d; done
29
+	rm -rf ${BUILD_SRC}/../${SOURCE_PKG}
30
+	rm -rf ${BUILD_SRC}/pkg
31
+	# Create docker debian files
32
+	cd ${BUILD_SRC}; tar czf ../${SOURCE_PKG} .
33
+	cd ${BUILD_SRC}; dpkg-buildpackage
34
+	rm -rf ${BUILD_SRC}
0 35
new file mode 100644
... ...
@@ -0,0 +1,31 @@
0
+Docker on Debian
1
+================
2
+
3
+Docker has been built and tested on Wheezy. All docker functionality works
4
+out of the box, except for memory limitation as the stock debian kernel
5
+does not support it yet.
6
+
7
+
8
+Building docker package
9
+~~~~~~~~~~~~~~~~~~~~~~~
10
+
11
+Building Dependencies: debhelper, autotools-dev and golang
12
+
13
+
14
+Assuming you have a wheezy system up and running
15
+
16
+# Download a fresh copy of the docker project
17
+git clone https://github.com/dotcloud/docker.git
18
+cd docker
19
+
20
+# Get building dependencies
21
+sudo apt-get update ; sudo apt-get install -y debhelper autotools-dev golang
22
+
23
+# Make the debian package, with no memory limitation support
24
+(cd packaging/debian; make debian NO_MEMORY_LIMIT=1)
25
+
26
+
27
+Install docker package
28
+~~~~~~~~~~~~~~~~~~~~~~
29
+
30
+sudo dpkg -i lxc-docker_0.1.4-1_amd64.deb; sudo apt-get install -f -y
0 31
new file mode 100644
... ...
@@ -0,0 +1,22 @@
0
+# -*- mode: ruby -*-
1
+# vi: set ft=ruby :
2
+
3
+$BUILDBOT_IP = '192.168.33.31'
4
+
5
+def v10(config)
6
+  config.vm.box = 'debian'
7
+  config.vm.share_folder 'v-data', '/data/docker', File.dirname(__FILE__) + '/../..'
8
+  config.vm.network :hostonly, $BUILDBOT_IP
9
+
10
+  # Install debian packaging dependencies and create debian packages
11
+  config.vm.provision :shell, :inline => 'apt-get -qq update; apt-get install -y debhelper autotools-dev golang'
12
+  config.vm.provision :shell, :inline => 'cd /data/docker/packaging/debian; make debian'
13
+end
14
+
15
+Vagrant::VERSION < '1.1.0' and Vagrant::Config.run do |config|
16
+  v10(config)
17
+end
18
+
19
+Vagrant::VERSION >= '1.1.0' and Vagrant.configure('1') do |config|
20
+  v10(config)
21
+end
0 22
new file mode 100644
... ...
@@ -0,0 +1,14 @@
0
+lxc-docker (0.1.4-1) unstable; urgency=low
1
+
2
+  Improvements [+], Updates [*], Bug fixes [-]:
3
+  * Changed default bridge interface do 'docker0'
4
+  - Fix a race condition when running the port allocator
5
+
6
+ -- Daniel Mizyrycki <daniel@dotcloud.com>  Wed, 10 Apr 2013 18:06:21 -0700
7
+
8
+
9
+lxc-docker (0.1.0-1) unstable; urgency=low
10
+
11
+  * Initial release
12
+
13
+ -- Daniel Mizyrycki <daniel@dotcloud.com>  Mon, 29 Mar 2013 18:09:55 -0700
0 14
new file mode 100644
... ...
@@ -0,0 +1 @@
0
+9
0 1
new file mode 100644
... ...
@@ -0,0 +1,19 @@
0
+Source: lxc-docker
1
+Section: admin
2
+Priority: optional
3
+Maintainer: Daniel Mizyrycki <daniel@dotcloud.com>
4
+Build-Depends: debhelper (>= 9),autotools-dev,golang
5
+Standards-Version: 3.9.3
6
+Homepage: http://github.com/dotcloud/docker
7
+
8
+Package: lxc-docker
9
+Architecture: linux-any
10
+Depends: ${misc:Depends},${shlibs:Depends},lxc,bsdtar
11
+Conflicts: docker
12
+Description: lxc-docker is a Linux container runtime
13
+ Docker complements LXC with a high-level API which operates at the process
14
+ level. It runs unix processes with strong guarantees of isolation and
15
+ repeatability across servers.
16
+ Docker is a great building block for automating distributed systems:
17
+ large-scale web deployments, database clusters, continuous deployment systems,
18
+ private PaaS, service-oriented architectures, etc.
0 19
new file mode 100644
... ...
@@ -0,0 +1,237 @@
0
+Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
1
+Upstream-Name: docker
2
+Upstream-Contact: DotCloud Inc <opensource@dotcloud.com>
3
+Source: http://github.com/dotcloud/docker
4
+
5
+Files: *
6
+Copyright: 2012, DotCloud Inc <opensource@dotcloud.com>
7
+License: Apache-2.0
8
+ Apache License
9
+ Version 2.0, January 2004
10
+ http://www.apache.org/licenses/
11
+ 
12
+ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
13
+ 
14
+ 1. Definitions.
15
+ 
16
+ "License" shall mean the terms and conditions for use, reproduction,
17
+ and distribution as defined by Sections 1 through 9 of this document.
18
+ 
19
+ "Licensor" shall mean the copyright owner or entity authorized by
20
+ the copyright owner that is granting the License.
21
+ 
22
+ "Legal Entity" shall mean the union of the acting entity and all
23
+ other entities that control, are controlled by, or are under common
24
+ control with that entity. For the purposes of this definition,
25
+ "control" means (i) the power, direct or indirect, to cause the
26
+ direction or management of such entity, whether by contract or
27
+ otherwise, or (ii) ownership of fifty percent (50%) or more of the
28
+ outstanding shares, or (iii) beneficial ownership of such entity.
29
+ 
30
+ "You" (or "Your") shall mean an individual or Legal Entity
31
+ exercising permissions granted by this License.
32
+ 
33
+ "Source" form shall mean the preferred form for making modifications,
34
+ including but not limited to software source code, documentation
35
+ source, and configuration files.
36
+ 
37
+ "Object" form shall mean any form resulting from mechanical
38
+ transformation or translation of a Source form, including but
39
+ not limited to compiled object code, generated documentation,
40
+ and conversions to other media types.
41
+ 
42
+ "Work" shall mean the work of authorship, whether in Source or
43
+ Object form, made available under the License, as indicated by a
44
+ copyright notice that is included in or attached to the work
45
+ (an example is provided in the Appendix below).
46
+ 
47
+ "Derivative Works" shall mean any work, whether in Source or Object
48
+ form, that is based on (or derived from) the Work and for which the
49
+ editorial revisions, annotations, elaborations, or other modifications
50
+ represent, as a whole, an original work of authorship. For the purposes
51
+ of this License, Derivative Works shall not include works that remain
52
+ separable from, or merely link (or bind by name) to the interfaces of,
53
+ the Work and Derivative Works thereof.
54
+ 
55
+ "Contribution" shall mean any work of authorship, including
56
+ the original version of the Work and any modifications or additions
57
+ to that Work or Derivative Works thereof, that is intentionally
58
+ submitted to Licensor for inclusion in the Work by the copyright owner
59
+ or by an individual or Legal Entity authorized to submit on behalf of
60
+ the copyright owner. For the purposes of this definition, "submitted"
61
+ means any form of electronic, verbal, or written communication sent
62
+ to the Licensor or its representatives, including but not limited to
63
+ communication on electronic mailing lists, source code control systems,
64
+ and issue tracking systems that are managed by, or on behalf of, the
65
+ Licensor for the purpose of discussing and improving the Work, but
66
+ excluding communication that is conspicuously marked or otherwise
67
+ designated in writing by the copyright owner as "Not a Contribution."
68
+ 
69
+ "Contributor" shall mean Licensor and any individual or Legal Entity
70
+ on behalf of whom a Contribution has been received by Licensor and
71
+ subsequently incorporated within the Work.
72
+ 
73
+ 2. Grant of Copyright License. Subject to the terms and conditions of
74
+ this License, each Contributor hereby grants to You a perpetual,
75
+ worldwide, non-exclusive, no-charge, royalty-free, irrevocable
76
+ copyright license to reproduce, prepare Derivative Works of,
77
+ publicly display, publicly perform, sublicense, and distribute the
78
+ Work and such Derivative Works in Source or Object form.
79
+ 
80
+ 3. Grant of Patent License. Subject to the terms and conditions of
81
+ this License, each Contributor hereby grants to You a perpetual,
82
+ worldwide, non-exclusive, no-charge, royalty-free, irrevocable
83
+ (except as stated in this section) patent license to make, have made,
84
+ use, offer to sell, sell, import, and otherwise transfer the Work,
85
+ where such license applies only to those patent claims licensable
86
+ by such Contributor that are necessarily infringed by their
87
+ Contribution(s) alone or by combination of their Contribution(s)
88
+ with the Work to which such Contribution(s) was submitted. If You
89
+ institute patent litigation against any entity (including a
90
+ cross-claim or counterclaim in a lawsuit) alleging that the Work
91
+ or a Contribution incorporated within the Work constitutes direct
92
+ or contributory patent infringement, then any patent licenses
93
+ granted to You under this License for that Work shall terminate
94
+ as of the date such litigation is filed.
95
+ 
96
+ 4. Redistribution. You may reproduce and distribute copies of the
97
+ Work or Derivative Works thereof in any medium, with or without
98
+ modifications, and in Source or Object form, provided that You
99
+ meet the following conditions:
100
+ 
101
+ (a) You must give any other recipients of the Work or
102
+ Derivative Works a copy of this License; and
103
+ 
104
+ (b) You must cause any modified files to carry prominent notices
105
+ stating that You changed the files; and
106
+ 
107
+ (c) You must retain, in the Source form of any Derivative Works
108
+ that You distribute, all copyright, patent, trademark, and
109
+ attribution notices from the Source form of the Work,
110
+ excluding those notices that do not pertain to any part of
111
+ the Derivative Works; and
112
+ 
113
+ (d) If the Work includes a "NOTICE" text file as part of its
114
+ distribution, then any Derivative Works that You distribute must
115
+ include a readable copy of the attribution notices contained
116
+ within such NOTICE file, excluding those notices that do not
117
+ pertain to any part of the Derivative Works, in at least one
118
+ of the following places: within a NOTICE text file distributed
119
+ as part of the Derivative Works; within the Source form or
120
+ documentation, if provided along with the Derivative Works; or,
121
+ within a display generated by the Derivative Works, if and
122
+ wherever such third-party notices normally appear. The contents
123
+ of the NOTICE file are for informational purposes only and
124
+ do not modify the License. You may add Your own attribution
125
+ notices within Derivative Works that You distribute, alongside
126
+ or as an addendum to the NOTICE text from the Work, provided
127
+ that such additional attribution notices cannot be construed
128
+ as modifying the License.
129
+ 
130
+ You may add Your own copyright statement to Your modifications and
131
+ may provide additional or different license terms and conditions
132
+ for use, reproduction, or distribution of Your modifications, or
133
+ for any such Derivative Works as a whole, provided Your use,
134
+ reproduction, and distribution of the Work otherwise complies with
135
+ the conditions stated in this License.
136
+ 
137
+ 5. Submission of Contributions. Unless You explicitly state otherwise,
138
+ any Contribution intentionally submitted for inclusion in the Work
139
+ by You to the Licensor shall be under the terms and conditions of
140
+ this License, without any additional terms or conditions.
141
+ Notwithstanding the above, nothing herein shall supersede or modify
142
+ the terms of any separate license agreement you may have executed
143
+ with Licensor regarding such Contributions.
144
+ 
145
+ 6. Trademarks. This License does not grant permission to use the trade
146
+ names, trademarks, service marks, or product names of the Licensor,
147
+ except as required for reasonable and customary use in describing the
148
+ origin of the Work and reproducing the content of the NOTICE file.
149
+ 
150
+ 7. Disclaimer of Warranty. Unless required by applicable law or
151
+ agreed to in writing, Licensor provides the Work (and each
152
+ Contributor provides its Contributions) on an "AS IS" BASIS,
153
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
154
+ implied, including, without limitation, any warranties or conditions
155
+ of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
156
+ PARTICULAR PURPOSE. You are solely responsible for determining the
157
+ appropriateness of using or redistributing the Work and assume any
158
+ risks associated with Your exercise of permissions under this License.
159
+ 
160
+ 8. Limitation of Liability. In no event and under no legal theory,
161
+ whether in tort (including negligence), contract, or otherwise,
162
+ unless required by applicable law (such as deliberate and grossly
163
+ negligent acts) or agreed to in writing, shall any Contributor be
164
+ liable to You for damages, including any direct, indirect, special,
165
+ incidental, or consequential damages of any character arising as a
166
+ result of this License or out of the use or inability to use the
167
+ Work (including but not limited to damages for loss of goodwill,
168
+ work stoppage, computer failure or malfunction, or any and all
169
+ other commercial damages or losses), even if such Contributor
170
+ has been advised of the possibility of such damages.
171
+ 
172
+ 9. Accepting Warranty or Additional Liability. While redistributing
173
+ the Work or Derivative Works thereof, You may choose to offer,
174
+ and charge a fee for, acceptance of support, warranty, indemnity,
175
+ or other liability obligations and/or rights consistent with this
176
+ License. However, in accepting such obligations, You may act only
177
+ on Your own behalf and on Your sole responsibility, not on behalf
178
+ of any other Contributor, and only if You agree to indemnify,
179
+ defend, and hold each Contributor harmless for any liability
180
+ incurred by, or claims asserted against, such Contributor by reason
181
+ of your accepting any such warranty or additional liability.
182
+ 
183
+ END OF TERMS AND CONDITIONS
184
+ 
185
+ APPENDIX: How to apply the Apache License to your work.
186
+ 
187
+ To apply the Apache License to your work, attach the following
188
+ boilerplate notice, with the fields enclosed by brackets "[]"
189
+ replaced with your own identifying information. (Don't include
190
+ the brackets!) The text should be enclosed in the appropriate
191
+ comment syntax for the file format. We also recommend that a
192
+ file or class name and description of purpose be included on the
193
+ same "printed page" as the copyright notice for easier
194
+ identification within third-party archives.
195
+ 
196
+ Copyright 2012 DotCloud Inc
197
+ 
198
+ Licensed under the Apache License, Version 2.0 (the "License");
199
+ you may not use this file except in compliance with the License.
200
+ You may obtain a copy of the License at
201
+ 
202
+ http://www.apache.org/licenses/LICENSE-2.0
203
+ 
204
+ Unless required by applicable law or agreed to in writing, software
205
+ distributed under the License is distributed on an "AS IS" BASIS,
206
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
207
+ See the License for the specific language governing permissions and
208
+ limitations under the License.
209
+ 
210
+ 
211
+Files: src/github.com/kr/pty/*
212
+Copyright: Copyright (c) 2011 Keith Rarick
213
+License: Expat
214
+ Copyright (c) 2011 Keith Rarick
215
+ 
216
+ Permission is hereby granted, free of charge, to any person
217
+ obtaining a copy of this software and associated
218
+ documentation files (the "Software"), to deal in the
219
+ Software without restriction, including without limitation
220
+ the rights to use, copy, modify, merge, publish, distribute,
221
+ sublicense, and/or sell copies of the Software, and to
222
+ permit persons to whom the Software is furnished to do so,
223
+ subject to the following conditions:
224
+ 
225
+ The above copyright notice and this permission notice shall
226
+ be included in all copies or substantial portions of the
227
+ Software.
228
+ 
229
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
230
+ KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
231
+ WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
232
+ PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
233
+ OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
234
+ OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
235
+ OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
236
+ SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
0 237
new file mode 100644
... ...
@@ -0,0 +1,49 @@
0
+#!/bin/sh
1
+
2
+### BEGIN INIT INFO
3
+# Provides:          docker
4
+# Required-Start:    $local_fs
5
+# Required-Stop:     $local_fs
6
+# Default-Start:     2 3 4 5
7
+# Default-Stop:      0 1 6
8
+# Short-Description: docker
9
+# Description:       docker daemon
10
+### END INIT INFO
11
+
12
+DOCKER=/usr/bin/docker
13
+PIDFILE=/var/run/docker.pid
14
+
15
+# Check docker is present
16
+[ -x $DOCKER ] || log_success_msg "Docker not present"
17
+
18
+# Get lsb functions
19
+. /lib/lsb/init-functions
20
+
21
+
22
+case "$1" in
23
+  start)
24
+    log_begin_msg "Starting docker..."
25
+    start-stop-daemon --start --background --exec "$DOCKER" -- -d
26
+    log_end_msg $?
27
+    ;;
28
+  stop)
29
+    log_begin_msg "Stopping docker..."
30
+    docker_pid=`pgrep -f "$DOCKER -d"`
31
+    [ -n "$docker_pid" ] && kill $docker_pid
32
+    log_end_msg $?
33
+    ;;
34
+  status)
35
+    docker_pid=`pgrep -f "$DOCKER -d"`
36
+    if [ -z "$docker_pid" ] ; then
37
+      echo "docker not running"
38
+    else
39
+      echo "docker running (pid $docker_pid)"
40
+    fi
41
+    ;;
42
+  *)
43
+    echo "Usage: /etc/init.d/docker {start|stop|status}"
44
+    exit 1
45
+    ;;
46
+esac
47
+
48
+exit 0
0 49
new file mode 100644
... ...
@@ -0,0 +1 @@
0
+README.md
0 1
new file mode 100644
... ...
@@ -0,0 +1,13 @@
0
+#!/bin/sh
1
+
2
+# Ensure cgroup is mounted
3
+if [ -z "`/bin/egrep -e '^cgroup' /etc/fstab`" ]; then
4
+    /bin/echo 'cgroup  /sys/fs/cgroup  cgroup  defaults  0   0' >>/etc/fstab
5
+fi
6
+if [ -z "`/bin/mount | /bin/egrep -e '^cgroup'`" ]; then
7
+    /bin/mount /sys/fs/cgroup
8
+fi
9
+
10
+# Start docker
11
+/usr/sbin/update-rc.d docker defaults
12
+/etc/init.d/docker start
0 13
new file mode 100644
... ...
@@ -0,0 +1,16 @@
0
+Maintainer duty
1
+===============
2
+
3
+The Debian project specifies the role of a 'maintainer' which is the person
4
+making the Debian package of the program. This role requires an 'sponsor' to
5
+upload the package. As a maintainer you should follow the guide
6
+http://www.debian.org/doc/manuals/maint-guide . Your sponsor will be there
7
+helping you succeed.
8
+
9
+The most relevant information to update is the changelog file:
10
+Each new release should create a new first paragraph with new release version,
11
+changes, and the maintainer information.
12
+
13
+After this is done, follow README.debian to generate the actual source
14
+packages and talk with your sponsor to upload them into the official Debian
15
+package archive.
0 16
new file mode 100755
... ...
@@ -0,0 +1,13 @@
0
+#!/usr/bin/make -f
1
+# -*- makefile -*-
2
+# Sample debian/rules that uses debhelper.
3
+# This file was originally written by Joey Hess and Craig Small.
4
+# As a special exception, when this file is copied by dh-make into a
5
+# dh-make output file, you may use that output file without restriction.
6
+# This special exception was added by Craig Small in version 0.37 of dh-make.
7
+
8
+# Uncomment this to turn on verbose mode.
9
+#export DH_VERBOSE=1
10
+
11
+%:
12
+	dh ${@} --with autotools_dev
0 13
new file mode 100644
... ...
@@ -0,0 +1 @@
0
+3.0 (quilt)
0 1
new file mode 100644
... ...
@@ -0,0 +1,73 @@
0
+PKG_NAME=lxc-docker
1
+PKG_ARCH=amd64
2
+PKG_VERSION=1
3
+ROOT_PATH:=$(PWD)
4
+BUILD_PATH=build	# Do not change, decided by dpkg-buildpackage
5
+BUILD_SRC=build_src
6
+GITHUB_PATH=src/github.com/dotcloud/docker
7
+INSDIR=usr/bin
8
+SOURCE_PACKAGE=$(PKG_NAME)_$(PKG_VERSION).orig.tar.gz
9
+DEB_PACKAGE=$(PKG_NAME)_$(PKG_VERSION)_$(PKG_ARCH).deb
10
+EXTRA_GO_PKG=./auth
11
+
12
+TMPDIR=$(shell mktemp -d -t XXXXXX)
13
+
14
+
15
+# Build a debian source package
16
+all: clean build_in_deb
17
+
18
+build_in_deb:
19
+	echo "GOPATH = " $(ROOT_PATH)
20
+	mkdir bin
21
+	cd $(GITHUB_PATH)/docker; GOPATH=$(ROOT_PATH) go build -o $(ROOT_PATH)/bin/docker
22
+
23
+# DESTDIR provided by Debian packaging
24
+install:
25
+	# Call this from a go environment (as packaged for deb source package)
26
+	mkdir -p $(DESTDIR)/$(INSDIR)
27
+	mkdir -p $(DESTDIR)/etc/init
28
+	install -m 0755 bin/docker $(DESTDIR)/$(INSDIR)
29
+	install -o root -m 0755 etc/docker.upstart $(DESTDIR)/etc/init/docker.conf
30
+
31
+$(BUILD_SRC): clean
32
+	# Copy ourselves into $BUILD_SRC to comply with unusual golang constraints
33
+	tar --exclude=*.tar.gz --exclude=checkout.tgz -f checkout.tgz -cz *
34
+	mkdir -p $(BUILD_SRC)/$(GITHUB_PATH)
35
+	tar -f checkout.tgz -C $(BUILD_SRC)/$(GITHUB_PATH) -xz
36
+	cd $(BUILD_SRC)/$(GITHUB_PATH)/docker; GOPATH=$(ROOT_PATH)/$(BUILD_SRC) go get -d
37
+	for d in `find $(BUILD_SRC) -name '.git*'`; do rm -rf $$d; done
38
+	# Populate source build with debian stuff
39
+	cp -R -L ./deb/* $(BUILD_SRC)
40
+
41
+$(SOURCE_PACKAGE): $(BUILD_SRC)
42
+	rm -f $(SOURCE_PACKAGE)
43
+	# Create the debian source package
44
+	tar -f $(SOURCE_PACKAGE) -C ${ROOT_PATH}/${BUILD_SRC} -cz .
45
+
46
+# Build deb package fetching go dependencies and cleaning up git repositories
47
+deb: $(DEB_PACKAGE)
48
+
49
+$(DEB_PACKAGE): $(SOURCE_PACKAGE)
50
+	# dpkg-buildpackage looks for source package tarball in ../
51
+	cd $(BUILD_SRC); dpkg-buildpackage
52
+	rm -rf $(BUILD_PATH) debian/$(PKG_NAME)* debian/files
53
+
54
+debsrc: $(SOURCE_PACKAGE)
55
+
56
+# Build local sources
57
+#$(PKG_NAME): build_local
58
+
59
+build_local:
60
+	-@mkdir -p bin
61
+	cd docker && go build -o ../bin/docker
62
+
63
+gotest:
64
+	@echo "\033[36m[Testing]\033[00m docker..."
65
+	@sudo -E GOPATH=$(ROOT_PATH)/$(BUILD_SRC) go test -v . $(EXTRA_GO_PKG) && \
66
+		echo -n "\033[32m[OK]\033[00m" || \
67
+		echo -n "\033[31m[FAIL]\033[00m"; \
68
+		echo " docker"
69
+	@sudo rm -rf /tmp/docker-*
70
+
71
+clean:
72
+	rm -rf $(BUILD_PATH) debian/$(PKG_NAME)* debian/files $(BUILD_SRC) checkout.tgz bin
0 73
new file mode 100644
... ...
@@ -0,0 +1,5 @@
0
+lxc-docker (1) precise; urgency=low
1
+
2
+  * Initial release
3
+
4
+ -- dotCloud <ops@dotcloud.com>  Mon, 25 Mar 2013 05:51:12 -0700
0 5
new file mode 100644
... ...
@@ -0,0 +1 @@
0
+8
0 1
new file mode 100644
... ...
@@ -0,0 +1,19 @@
0
+Source: lxc-docker
1
+Section: misc
2
+Priority: extra
3
+Homepage: http://docker.io
4
+Maintainer: Daniel Mizyrycki <daniel@dotcloud.com>
5
+Build-Depends: debhelper (>= 8.0.0), pkg-config, git, golang, libsqlite3-dev
6
+Vcs-Git: http://github.com/dotcloud/docker.git
7
+Standards-Version: 3.9.3
8
+
9
+Package: lxc-docker
10
+Architecture: amd64
11
+Depends: ${shlibs:Depends}, ${misc:Depends}, lxc, wget, bsdtar, curl, sqlite3
12
+Conflicts: docker
13
+Description: A process manager with superpowers
14
+    It encapsulates heterogeneous payloads in Standard Containers, and runs
15
+    them on any server with strong guarantees of isolation and repeatability.
16
+    Is is a great building block for automating distributed systems:
17
+    large-scale web deployments, database clusters, continuous deployment
18
+    systems, private PaaS, service-oriented architectures, etc.
0 19
new file mode 100644
... ...
@@ -0,0 +1,209 @@
0
+Format: http://dep.debian.net/deps/dep5
1
+Upstream-Name: docker
2
+Source: https://github.com/dotcloud/docker
3
+
4
+Files: *
5
+Copyright: 2012 DotCloud Inc (opensource@dotcloud.com)
6
+License: Apache License Version 2.0
7
+
8
+                                Apache License
9
+                           Version 2.0, January 2004
10
+                        http://www.apache.org/licenses/
11
+
12
+   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
13
+
14
+   1. Definitions.
15
+
16
+      "License" shall mean the terms and conditions for use, reproduction,
17
+      and distribution as defined by Sections 1 through 9 of this document.
18
+
19
+      "Licensor" shall mean the copyright owner or entity authorized by
20
+      the copyright owner that is granting the License.
21
+
22
+      "Legal Entity" shall mean the union of the acting entity and all
23
+      other entities that control, are controlled by, or are under common
24
+      control with that entity. For the purposes of this definition,
25
+      "control" means (i) the power, direct or indirect, to cause the
26
+      direction or management of such entity, whether by contract or
27
+      otherwise, or (ii) ownership of fifty percent (50%) or more of the
28
+      outstanding shares, or (iii) beneficial ownership of such entity.
29
+
30
+      "You" (or "Your") shall mean an individual or Legal Entity
31
+      exercising permissions granted by this License.
32
+
33
+      "Source" form shall mean the preferred form for making modifications,
34
+      including but not limited to software source code, documentation
35
+      source, and configuration files.
36
+
37
+      "Object" form shall mean any form resulting from mechanical
38
+      transformation or translation of a Source form, including but
39
+      not limited to compiled object code, generated documentation,
40
+      and conversions to other media types.
41
+
42
+      "Work" shall mean the work of authorship, whether in Source or
43
+      Object form, made available under the License, as indicated by a
44
+      copyright notice that is included in or attached to the work
45
+      (an example is provided in the Appendix below).
46
+
47
+      "Derivative Works" shall mean any work, whether in Source or Object
48
+      form, that is based on (or derived from) the Work and for which the
49
+      editorial revisions, annotations, elaborations, or other modifications
50
+      represent, as a whole, an original work of authorship. For the purposes
51
+      of this License, Derivative Works shall not include works that remain
52
+      separable from, or merely link (or bind by name) to the interfaces of,
53
+      the Work and Derivative Works thereof.
54
+
55
+      "Contribution" shall mean any work of authorship, including
56
+      the original version of the Work and any modifications or additions
57
+      to that Work or Derivative Works thereof, that is intentionally
58
+      submitted to Licensor for inclusion in the Work by the copyright owner
59
+      or by an individual or Legal Entity authorized to submit on behalf of
60
+      the copyright owner. For the purposes of this definition, "submitted"
61
+      means any form of electronic, verbal, or written communication sent
62
+      to the Licensor or its representatives, including but not limited to
63
+      communication on electronic mailing lists, source code control systems,
64
+      and issue tracking systems that are managed by, or on behalf of, the
65
+      Licensor for the purpose of discussing and improving the Work, but
66
+      excluding communication that is conspicuously marked or otherwise
67
+      designated in writing by the copyright owner as "Not a Contribution."
68
+
69
+      "Contributor" shall mean Licensor and any individual or Legal Entity
70
+      on behalf of whom a Contribution has been received by Licensor and
71
+      subsequently incorporated within the Work.
72
+
73
+   2. Grant of Copyright License. Subject to the terms and conditions of
74
+      this License, each Contributor hereby grants to You a perpetual,
75
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
76
+      copyright license to reproduce, prepare Derivative Works of,
77
+      publicly display, publicly perform, sublicense, and distribute the
78
+      Work and such Derivative Works in Source or Object form.
79
+
80
+   3. Grant of Patent License. Subject to the terms and conditions of
81
+      this License, each Contributor hereby grants to You a perpetual,
82
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
83
+      (except as stated in this section) patent license to make, have made,
84
+      use, offer to sell, sell, import, and otherwise transfer the Work,
85
+      where such license applies only to those patent claims licensable
86
+      by such Contributor that are necessarily infringed by their
87
+      Contribution(s) alone or by combination of their Contribution(s)
88
+      with the Work to which such Contribution(s) was submitted. If You
89
+      institute patent litigation against any entity (including a
90
+      cross-claim or counterclaim in a lawsuit) alleging that the Work
91
+      or a Contribution incorporated within the Work constitutes direct
92
+      or contributory patent infringement, then any patent licenses
93
+      granted to You under this License for that Work shall terminate
94
+      as of the date such litigation is filed.
95
+
96
+   4. Redistribution. You may reproduce and distribute copies of the
97
+      Work or Derivative Works thereof in any medium, with or without
98
+      modifications, and in Source or Object form, provided that You
99
+      meet the following conditions:
100
+
101
+      (a) You must give any other recipients of the Work or
102
+          Derivative Works a copy of this License; and
103
+
104
+      (b) You must cause any modified files to carry prominent notices
105
+          stating that You changed the files; and
106
+
107
+      (c) You must retain, in the Source form of any Derivative Works
108
+          that You distribute, all copyright, patent, trademark, and
109
+          attribution notices from the Source form of the Work,
110
+          excluding those notices that do not pertain to any part of
111
+          the Derivative Works; and
112
+
113
+      (d) If the Work includes a "NOTICE" text file as part of its
114
+          distribution, then any Derivative Works that You distribute must
115
+          include a readable copy of the attribution notices contained
116
+          within such NOTICE file, excluding those notices that do not
117
+          pertain to any part of the Derivative Works, in at least one
118
+          of the following places: within a NOTICE text file distributed
119
+          as part of the Derivative Works; within the Source form or
120
+          documentation, if provided along with the Derivative Works; or,
121
+          within a display generated by the Derivative Works, if and
122
+          wherever such third-party notices normally appear. The contents
123
+          of the NOTICE file are for informational purposes only and
124
+          do not modify the License. You may add Your own attribution
125
+          notices within Derivative Works that You distribute, alongside
126
+          or as an addendum to the NOTICE text from the Work, provided
127
+          that such additional attribution notices cannot be construed
128
+          as modifying the License.
129
+
130
+      You may add Your own copyright statement to Your modifications and
131
+      may provide additional or different license terms and conditions
132
+      for use, reproduction, or distribution of Your modifications, or
133
+      for any such Derivative Works as a whole, provided Your use,
134
+      reproduction, and distribution of the Work otherwise complies with
135
+      the conditions stated in this License.
136
+
137
+   5. Submission of Contributions. Unless You explicitly state otherwise,
138
+      any Contribution intentionally submitted for inclusion in the Work
139
+      by You to the Licensor shall be under the terms and conditions of
140
+      this License, without any additional terms or conditions.
141
+      Notwithstanding the above, nothing herein shall supersede or modify
142
+      the terms of any separate license agreement you may have executed
143
+      with Licensor regarding such Contributions.
144
+
145
+   6. Trademarks. This License does not grant permission to use the trade
146
+      names, trademarks, service marks, or product names of the Licensor,
147
+      except as required for reasonable and customary use in describing the
148
+      origin of the Work and reproducing the content of the NOTICE file.
149
+
150
+   7. Disclaimer of Warranty. Unless required by applicable law or
151
+      agreed to in writing, Licensor provides the Work (and each
152
+      Contributor provides its Contributions) on an "AS IS" BASIS,
153
+      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
154
+      implied, including, without limitation, any warranties or conditions
155
+      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
156
+      PARTICULAR PURPOSE. You are solely responsible for determining the
157
+      appropriateness of using or redistributing the Work and assume any
158
+      risks associated with Your exercise of permissions under this License.
159
+
160
+   8. Limitation of Liability. In no event and under no legal theory,
161
+      whether in tort (including negligence), contract, or otherwise,
162
+      unless required by applicable law (such as deliberate and grossly
163
+      negligent acts) or agreed to in writing, shall any Contributor be
164
+      liable to You for damages, including any direct, indirect, special,
165
+      incidental, or consequential damages of any character arising as a
166
+      result of this License or out of the use or inability to use the
167
+      Work (including but not limited to damages for loss of goodwill,
168
+      work stoppage, computer failure or malfunction, or any and all
169
+      other commercial damages or losses), even if such Contributor
170
+      has been advised of the possibility of such damages.
171
+
172
+   9. Accepting Warranty or Additional Liability. While redistributing
173
+      the Work or Derivative Works thereof, You may choose to offer,
174
+      and charge a fee for, acceptance of support, warranty, indemnity,
175
+      or other liability obligations and/or rights consistent with this
176
+      License. However, in accepting such obligations, You may act only
177
+      on Your own behalf and on Your sole responsibility, not on behalf
178
+      of any other Contributor, and only if You agree to indemnify,
179
+      defend, and hold each Contributor harmless for any liability
180
+      incurred by, or claims asserted against, such Contributor by reason
181
+      of your accepting any such warranty or additional liability.
182
+
183
+   END OF TERMS AND CONDITIONS
184
+
185
+   APPENDIX: How to apply the Apache License to your work.
186
+
187
+      To apply the Apache License to your work, attach the following
188
+      boilerplate notice, with the fields enclosed by brackets "[]"
189
+      replaced with your own identifying information. (Don't include
190
+      the brackets!) The text should be enclosed in the appropriate
191
+      comment syntax for the file format. We also recommend that a
192
+      file or class name and description of purpose be included on the
193
+      same "printed page" as the copyright notice for easier
194
+      identification within third-party archives.
195
+
196
+   Copyright 2012 DotCloud Inc (opensource@dotcloud.com)
197
+
198
+   Licensed under the Apache License, Version 2.0 (the "License");
199
+   you may not use this file except in compliance with the License.
200
+   You may obtain a copy of the License at
201
+
202
+       http://www.apache.org/licenses/LICENSE-2.0
203
+
204
+   Unless required by applicable law or agreed to in writing, software
205
+   distributed under the License is distributed on an "AS IS" BASIS,
206
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
207
+   See the License for the specific language governing permissions and
208
+   limitations under the License.
0 209
new file mode 100644
... ...
@@ -0,0 +1 @@
0
+README.md
0 1
new file mode 100755
... ...
@@ -0,0 +1,13 @@
0
+#!/usr/bin/make -f
1
+# -*- makefile -*-
2
+# Sample debian/rules that uses debhelper.
3
+# This file was originally written by Joey Hess and Craig Small.
4
+# As a special exception, when this file is copied by dh-make into a
5
+# dh-make output file, you may use that output file without restriction.
6
+# This special exception was added by Craig Small in version 0.37 of dh-make.
7
+
8
+# Uncomment this to turn on verbose mode.
9
+#export DH_VERBOSE=1
10
+
11
+%:
12
+	dh $@
0 13
new file mode 100644
... ...
@@ -0,0 +1 @@
0
+3.0 (quilt)
0 1
new file mode 100644
... ...
@@ -0,0 +1,10 @@
0
+description     "Run docker"
1
+
2
+start on runlevel [2345]
3
+stop on starting rc RUNLEVEL=[016]
4
+respawn
5
+
6
+script
7
+    test -f /etc/default/locale && . /etc/default/locale || true
8
+    LANG=$LANG LC_ALL=$LANG /usr/bin/docker -d
9
+end script